<template>
  <div id="quiz_edit" style="width: 600px">
    <el-form :model="quizForm" label-width="100px">
      <el-form-item id="quiz_type" :label="$t('QUESTION.TYPE')">
        <el-radio-group v-model="modifyQuestion.type" disabled>
          <el-radio-button label="1">{{
            $t("QUESTION.SHORT_ANS")
          }}</el-radio-button>
          <el-radio-button label="0">{{
            $t("QUESTION.MULTI_ANS")
          }}</el-radio-button>
          <el-radio-button label="2">{{ $t("QUESTION.FILE") }}</el-radio-button>
        </el-radio-group>
        <span> &nbsp; * {{ $t("QUESTION.QUES_TYPE_EDIT_NO") }} </span>
      </el-form-item>

      <div v-if="modifyQuestion.type !== '파일'">
        <el-form-item :label="$t('BOARD.TITLE')">
          <el-input
            v-model="modifyQuestion.name"
            :placeholder="$t('QUESTION.ENTER_TITLE')"
            type="textarea"
            :autosize="{ minRows: 2, maxRows: 3 }"
          ></el-input>
        </el-form-item>
        <el-form-item :label="$t('QUESTION.QUESTION')">
          <el-input
            v-model="modifyQuestion.question"
            :placeholder="$t('NOTIFY.ENTER_CONTENTS')"
            type="textarea"
            :autosize="{ minRows: 8, maxRows: 12 }"
          ></el-input>
        </el-form-item>

        <template v-if="modifyQuestion.type === '단답'">
          <el-form-item :label="$t('QUESTION.ANSWER')">
            <el-input
              v-for="(item, index) in modifyQuestion.answer"
              :key="index"
              v-model="modifyQuestion.answer[index]"
              :placeholder="$t('NOTIFY.ENTER_CONTENTS')"
              type="textarea"
            ></el-input>
          </el-form-item>
        </template>
        <template v-if="modifyQuestion.type === '객관'">
          <el-form-item :label="$t('QUESTION.CHOICE')">
            <el-checkbox-group
              v-model="modifyQuestion.answer"
              @change="handleAnswerListChange"
            >
              <div v-for="(item, index) in modifyQuestion.choice" :key="index">
                <el-checkbox :label="index + 1">{{ index + 1 }}.</el-checkbox>
                <el-input
                  v-model="modifyQuestion.choice[index]"
                  :placeholder="$t('NOTIFY.ENTER_CONTENTS')"
                  class="answer-list"
                ></el-input>
              </div>
            </el-checkbox-group>
          </el-form-item>
        </template>
        <el-form-item :label="$t('QUESTION.LEVEL')">
          <el-select v-model="modifyQuestion.difficulty">
            <el-option v-for="diff in diffList" :key="diff" :value="diff">
            </el-option>
          </el-select>
        </el-form-item>
      </div>
      <div v-else>
        <el-form-item :label="$t('BOARD.TITLE')">
          <el-input
            v-model="modifyQuestion.name"
            :placeholder="$t('QUESTION.ENTER_TITLE')"
            type="textarea"
            :autosize="{ minRows: 2, maxRows: 3 }"
          ></el-input>
        </el-form-item>
        <el-form-item :label="$t('HELP.EXPLANATION')">
          <el-input
            v-model="modifyQuestion.question"
            :placeholder="$t('NOTIFY.ENTER_CONTENTS')"
            type="textarea"
            :autosize="{ minRows: 8, maxRows: 12 }"
          ></el-input>
        </el-form-item>

        <el-upload
          style="margin-left: 100px"
          action="#"
          :auto-upload="false"
          :on-change="handleChange"
          :on-remove="handleRemove"
          :file-list="updateFileList"
          ref="questionUpload"
        >
          <el-button slot="trigger" type="primary">{{
            $t("UPLOAD.FILE_ADD")
          }}</el-button>
        </el-upload>
        <br />
        <el-form-item :label="$t('NOTE.YOUTUBE')">
          <el-input
            v-model="youtubeURL"
            :placeholder="$t('VIDEO.ENTER_URL')"
          ></el-input>
          <youtube
            v-if="
              youtubeURL
            "
            player-width="100%"
            id="video"
            :video-id="youtubeId(youtubeURL)"
            :player-vars="{ autoplay: 1, modestbranding: 1 }"
          />
        </el-form-item>
      </div>

      <el-form-item :label="$t('QUESTION.KEYWORD')">
        <div style="width: 50%; margin-bottom: 5px">
          <el-select
            v-model="keywordName"
            :placeholder="$t('QUESTION.KEYWORD')"
          >
            <el-option
              v-for="key in keyList"
              :key="key.keyword"
              :value="key.keyword"
            >
            </el-option>
          </el-select>
        </div>

        <el-select
          v-model="keywordPoint"
          :placeholder="$t('LECTURE_MANAGE.ALLOTS')"
        >
          <el-option v-for="pt in pts" :key="pt" :value="pt"> </el-option>
        </el-select>
        <el-button @click="onClick('ADD_KEYWORD')">{{
          $t("LECTURE_MANAGE.ADD")
        }}</el-button>

        <div v-for="(item, index) in myKeywordList" :key="item.keyword">
          <el-button
            >{{ item.keyword }} :: {{ item.score_portion
            }}{{ $t("LECTURE_MANAGE.SCORE") }}</el-button
          >
          <el-button
            @click="onClick('DELETE_KEYWORD', index)"
            type="danger"
            style="margin-bottom: 5px"
            >X</el-button
          >
        </div>
      </el-form-item>

      <div class="ps-align-right">
        <el-button type="primary" @click="onModify">{{
          $t("KEYWORD.EDIT")
        }}</el-button>
      </div>
    </el-form>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import { getIdFromURL } from 'vue-youtube-embed';
import studentService from "../../services/studentService";
import lectureService from "../../services/lectureService";

export default {
  name: "QuizEdit",
  data() {
    return {
      keyList: [{ keyword: "a" }, { keyword: "b" }],
      diffList: [5, 4, 3, 2, 1],
      pts: [5, 4, 3, 2, 1],
      myanswer: [],
      myKeywordList: [],
      keywordName: null,
      keywordPoint: null,
      questionType: 1,
      quizForm: null,
      initFileList: [],
      updateFileList: [],
      removeFileList: [],
      youtubeURL: '',
    };
  },
  async created() {
    const vm = this;
    // alert(`modify question - ${JSON.stringify(vm.modifyQuestion)}`);
    // 해당 문항의 키워드를 임시로 배열로 옮김
    while (vm.myKeywordList.length) {
      vm.myKeywordList.pop();
    }
    for (
      let i = 0;
      i < vm.modifyQuestion.student_question_keywords.length;
      i += 1
    ) {
      vm.myKeywordList.push(vm.modifyQuestion.student_question_keywords[i]);
    }
    // 해당 강의의 키워드를 불러옴
    const keywords = await lectureService.getLectureKeywords({
      lectureId: vm.lectureId,
    });
    vm.keyList = keywords.data;
    // alert(JSON.stringify(vm.myanswer));
    if (vm.modifyQuestion.type === "파일" && vm.modifyQuestion.files) {
      for (let i = 0; i < vm.modifyQuestion.files.length; i += 1) {
        const obj = {
          name: vm.modifyQuestion.files[i].file_name,
          url: vm.modifyQuestion.files[i].file_url,
          id: vm.modifyQuestion.files[i].id,
        };
        vm.updateFileList.push(obj);
        vm.initFileList.push(obj);
      }
    }

    // 파일 유형 수정시 youtubeURL 안뜨는 문제 수정 21.04.02
    vm.youtubeURL = vm.modifyQuestion.type === '파일' ? vm.modifyQuestion.answer : '';
    /*else {
      for (let i = 0; i < vm.modifyQuestion.answer.length; i += 1) {
        vm.modifyQuestion.answer[i] = parseInt(vm.modifyQuestion.answer[i], 10);
      }
    }*/
    // alert(JSON.stringify(vm.initFileList));
  },
  computed: {
    ...mapState("studentQuestion", ["modifyQuestion", "lectureId"]),
  },
  methods: {
    ...mapActions("studentQuestion", [
      "putQuestion",
      "deleteKeyword",
      "postKeyword",
      "updateStudentQuestionMode1",
    ]),
    youtubeId(URL) {
      return URL !== undefined ? getIdFromURL(URL) : '';
    },
    async questionEdit() {
      const vm = this;
      const lid = vm.lectureId;
      // const lid = vm.$route.params.lectureId;
      await studentService.getQuestion({ id: lid });
    },
    handleChange(file, filelist) {
      const vm = this;
      // file 용량 제한
      // alert(JSON.stringify(filelist));
      vm.updateFileList = filelist;
    },
    handleRemove(file) {
      const vm = this;
      vm.removeFileList.push(file);
    },
    handleExceed() {
      const vm = this;
      vm.$message.warning("업로드 가능한 파일 개수를 초과하였습니다.");
    },
    onClick(type, arg) {
      const vm = this;
      switch (type) {
        /*(case 'ADD_ANSWER': {
          vm.answer.push('');
          break;
        }
        case 'DELETE_ANSWER': {
          vm.answer.pop();
          break;
        } */
        case "ADD_KEYWORD": {
          if (vm.keywordName === null || vm.keywordPoint === null) {
            vm.$message.warning(vm.$t("NOTIFY.ENTER_KEY_SCORE"));
            break;
          } else {
            for (let i = 0; i < vm.myKeywordList.length; i += 1) {
              if (vm.myKeywordList[i].keyword === vm.keywordName) {
                vm.$notify({
                  title: vm.$t("NOTIFY.TITLE"),
                  message: vm.$t("NOTIFY.ALRDY_REG_KEY"),
                  type: "warning",
                });
                vm.keywordName = null;
                vm.keywordPoint = null;
                return;
              }
            }
            vm.myKeywordList.push({
              keyword: vm.keywordName,
              score_portion: vm.keywordPoint,
            });
            vm.keywordName = null;
            vm.keywordPoint = null;
            break;
          }
        }
        case "DELETE_KEYWORD": {
          vm.myKeywordList.splice(arg, 1);
          break;
        }
        default: {
          break;
        }
      }
    },
    handleAnswerListChange(val) {
      const vm = this;
      vm.modifyQuestion.answer = val;
      // alert(`change - ${JSON.stringify(vm.modifyQuestion.answer)}`);
    },
    async onModify() {
      const vm = this;
      // const lid = vm.$route.params.lectureId;
      const lid = vm.lectureId;
      let progress_ok = true;

      // 공통
      if (vm.myKeywordList.length === 0) {
        // 키워드 없는 경우
        progress_ok = false;
        vm.$notify({
          title: vm.$t("NOTIFY.TITLE"),
          message: vm.$t("NOTIFY.ENTER_KYWRD"),
          type: "warning",
        });
      } else if (vm.modifyQuestion.name === '') {
        // 제목 없는 경우
        progress_ok = false;
        vm.$notify({
          title: vm.$t("NOTIFY.TITLE"),
          message: vm.$t("NOTIFY.TITLE_REQ"),
          type: "warning",
        });
      }

      // 파일 첨부일 경우
      if (vm.modifyQuestion.type === "파일") {
        if (!(vm.initFileList.length || vm.youtubeURL)) {
          // 파일을 첨부 안했을 경우
          progress_ok = false;
          vm.$notify({
            title: vm.$t("NOTIFY.TITLE"),
            message: vm.$t("NOTIFY.ATTACH_FILE"),
            type: "warning",
          });
        } else if (vm.modifyQuestion.question === '') {
          // 설명을 입력 안했을 경우
          progress_ok = false;
          vm.$notify({
            title: vm.$t("NOTIFY.TITLE"),
            message: vm.$t("NOTIFY.ENTER_EXP"),
            type: "warning",
          });
        } else {
          vm.modifyQuestion.answer = [ vm.youtubeURL ];
        }
      } else {
        // 단답 + 객관일 경우
        if (vm.modifyQuestion.answer.length === 0) {
          // 답이 없는 경우
          progress_ok = false;
          vm.$notify({
            title: vm.$t("NOTIFY.TITLE"),
            message: vm.$t("NOTIFY.ENTER_ANS"),
            type: "warning",
          });
        } else {
          if (vm.modifyQuestion.answer[0].length === 0) {
            // 답이 없는 경우
            progress_ok = false;
            vm.$notify({
              title: vm.$t("NOTIFY.TITLE"),
              message: vm.$t("NOTIFY.ENTER_ANS"),
              type: "warning",
            });
          }
        }
        // 객관일 경우
        if (vm.modifyQuestion.type === "객관") {
          if (vm.modifyQuestion.choice.length < 1) {
            // 보기가 없는 경우
            progress_ok = false;
            vm.$notify({
              title: vm.$t("NOTIFY.TITLE"),
              message: vm.$t("NOTIFY.ENTER_CHO"),
              type: "warning",
            });
          } else {
            for (let i = 0; i < vm.modifyQuestion.choice.length; i++) {
              if (vm.modifyQuestion.choice[i].length === 0) {
                progress_ok = false;
                vm.$notify({
                  title: vm.$t("NOTIFY.TITLE"),
                  message: vm.$t("NOTIFY.ENTER_CHO"),
                  type: "warning",
                });
                break;
              }
            }
          }
        }
      }

      if (progress_ok) {
        const res = await vm.putQuestion({ data: vm.modifyQuestion });
        if (res.data) {
          await vm.deleteKeyword({
            id: lid,
            qId: vm.modifyQuestion.student_question_id,
          });
          await vm.postKeyword({
            id: lid,
            qId: vm.modifyQuestion.student_question_id,
            data: vm.myKeywordList,
          });
        } else {
          vm.$message.warning("수정 실패하였습니다. 다시한번 시도해주세요.");
        }
        for (let i = 0; i < vm.removeFileList.length; i += 1) {
          // delete request
          studentService.deleteFile({
            id: lid,
            qId: vm.modifyQuestion.student_question_id,
            fId: vm.removeFileList[i].id,
          });
        }
        for (let i = 0; i < vm.updateFileList.length; i += 1) {
          if (vm.updateFileList[i].status === "ready") {
            studentService.postFile({
              id: lid,
              qId: vm.modifyQuestion.student_question_id,
              file: vm.updateFileList[i].raw,
            });
          }
        }
        vm.$notify({
          title: vm.$t("NOTIFY.COMP_MODIFY"),
          message: vm.$t("NOTIFY.SUC_MODI_COMP"),
          type: "success",
        });
        vm.updateStudentQuestionMode1({ mode: 0 });
      }
    },
  },
};
</script>

<style>
.answer-list {
  display: inline-block;
  width: 80%;
  margin-left: 10px;
}
</style>